/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.WindowEvent;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Types;
import java.sql.SQLException;
import java.util.Vector;
import COM.Sun.Japan.yjs.mwt.ScrollableCanvas;
import COM.Sun.Japan.yjs.mwt.MessageDialog;
/**
 * f[^x[X̃e[u̓eS\EBhEB
 *
 * @version     %I% %E%
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class TableView extends Frame {
    /**
     * e[ũC[W`悷LoXB
     */
    ScrollableCanvas canvas;

    /**
     * e[u̖O
     */
    String tableName;

    /**
     * f[^x[Xւ̃RlNVB
     */
    Connection conn;

    /**
     * e[ũf[^ێBe[ůeJŏc肵`
     * Ńf[^ Vector ƂĎBȂ킿AJ̕\ 1 vf
     * ɎA 2 vfɃJA 3 vfȍ~Ɋef[^B
     */
    Vector dataCols;

    /**
     * e[u`掞̗]B
     */
    static final int xmargin = 20;
    static final int ymargin = 10;

    /**
     * f[^x[Xւ̃RlNVɎRXgN^B
     * @param c f[^x[Xւ̃RlNVB
     */
    public TableView(Connection c) {
        conn = c;
        // setup GUI
        canvas = new ScrollableCanvas();
        canvas.setCanvasBackground(Color.white);
        add("Center", canvas);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    }

    /**
     * e[uɎAe[u\B
     * @param name e[u
     */
    public void showTable(String name) {
        tableName = name;
        retrieveTable();
        setSize(500, 300);
        setTitle(name);
        canvas.clearCanvas();
        show();
        drawTable();
    }

    /**
     * e[ũf[^AJɃf[^ёւB
     */
    void retrieveTable() {
        if (conn == null || tableName == null || tableName.length() < 1) {
            dataCols = null;
            return;
        }
        dataCols = new Vector();
        // Ώۃe[ǔ
        try {
            Statement stmt;
            ResultSet rs;
            ResultSetMetaData rsmd;
            Vector[] colData;
            Vector col;
            String val ="";
            int i, ncol = 0;
            // ⍇킹̎s
            stmt = conn.createStatement();
            rs = stmt.executeQuery("SELECT * FROM " + tableName);
            // e[u\̒
            rsmd = rs.getMetaData();
            ncol = rsmd.getColumnCount();
            colData = new Vector[ncol];
            for (i = 1; i <= ncol; i++ ) {
                col = new Vector();
                col.addElement(new Integer(rsmd.getColumnDisplaySize(i)));
                col.addElement(rsmd.getColumnName(i));
                colData[i-1] = col;
                dataCols.addElement(col);
            }
            // JEf[^̎擾
            while (rs.next()) {
                for (i = 1; i <= ncol; i++) {
                    switch(rsmd.getColumnType(i)) {
                    case Types.BINARY:
                    case Types.VARBINARY:
                    case Types.LONGVARBINARY:
                        val = "(BINARY)";
                        break;
                    default:
                        val = rs.getString(i);
                        if (val == null)
                            val = "null";
                        break;
                    }
                    colData[i-1].addElement(val);
                }
            }
        } catch (SQLException ex) {
            dataCols = null;
            new MessageDialog(ex, this);
        }
    }

    /**
     * e[u̕`B
     */
    void drawTable() {
        Vector col;
        Graphics g = canvas.getGraphics();
        FontMetrics fm = g.getFontMetrics();
        Color lblc = new Color(0, 254, 254);
        Color tblc = new Color(254,254,239);
        int ch = fm.getHeight();
        int cw = fm.charWidth('W');
        int cols;
        int rows;
        String val;
        int i, c;
        int colw;
        int rwh = ch + ymargin;
        Point nw = new Point(30, 30);
        if (g == null || dataCols == null || dataCols.size() < 1)
            return;
        cols = dataCols.size();
        for (c = 0; c < cols; c++) {
            col = (Vector)dataCols.elementAt(c);
            rows = col.size() - 2;
            colw = fm.stringWidth((String)col.elementAt(1));
            for (i = 0; i < rows; i++) {
                val = (String)col.elementAt(i+2);
                if (val != null && val.length() > 0)
                    colw = Math.max(colw, fm.stringWidth(val));
            }
            colw += xmargin;
            g.setColor(lblc);
            g.fillRect(nw.x, nw.y, colw, rwh);
            g.setColor(tblc);
            g.fillRect(nw.x, nw.y+rwh, colw, rwh*rows);
            g.setColor(Color.black);
            for (i = 0; i <= rows ; i++) {
                val = (String)col.elementAt(i+1);
                if (val == null)
                    val = "";
                g.drawRect(nw.x, nw.y + rwh * i, colw, rwh);
                g.drawString(val, nw.x + xmargin / 2, nw.y + rwh * i + ch + ymargin / 2);
            }
            nw.x += colw;
        }
    }

    /**
     * CxgEnhOB
     * @param ev window Cxg
     */
    protected void processWindowEvent(WindowEvent ev) {
        if (ev.getId() == WindowEvent.WINDOW_CLOSING) {
            dispose();
        }
        super.processWindowEvent(ev);
    }
}
