/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;

/**
 * hCoo^_CAO GUI
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */

public class AddDriverDialogGUI extends Dialog implements WindowListener {

//    AddDriverDialog module;
    Label driverNameLabel;
    TextField driverNameTextField;
    Button odbcBridgeButton;
    Button weblogicButton;
    Button symantecButton;
    Button registerButton;
    Button cancelButton;

    public AddDriverDialogGUI(Frame mainFrame, AddDriverDialog module) {
        super(mainFrame);
	addWindowListener(this);
	setTitle("JDBCTerminal: Add Driver");

	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();
	
        // create driver name Label
        driverNameLabel = new Label("Driver Name:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(driverNameLabel, gbc);
        add(driverNameLabel);

        // create driver name TextField
        driverNameTextField = new TextField(35);
        gbc.gridy++;
        gbc.gridwidth = 3;
        gbl.setConstraints(driverNameTextField, gbc);
        add(driverNameTextField);

	// create odbcBridgeButton
	odbcBridgeButton = new Button("ODBC Bridge");
	gbc.gridy += 2;
	gbc.gridwidth = 1;
	gbc.anchor = GridBagConstraints.CENTER;
	gbl.setConstraints(odbcBridgeButton, gbc);
	odbcBridgeButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.OdbcBridge, module));
	add(odbcBridgeButton);

        // create weblogic Button
	weblogicButton = new Button("Weblogic");
	gbc.gridx++;
	gbl.setConstraints(weblogicButton, gbc);
	weblogicButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Weblogic, module));
	add(weblogicButton);

        // create symantec Button
	symantecButton = new Button("Symantec");
	gbc.gridx++;
	gbl.setConstraints(symantecButton, gbc);
	symantecButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Symantec, module));
	add(symantecButton);

        // create register Button
	registerButton = new Button("Register");
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbl.setConstraints(registerButton, gbc);
	registerButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Register, module));
	add(registerButton);

	cancelButton = new Button("Cancel");
	gbc.gridx += 2;
	gbl.setConstraints(cancelButton, gbc);
	cancelButton.addActionListener(new AddDriverDialogCommand(AddDriverDialogCommand.Cancel, module));
	add(cancelButton);

        pack();
    }

    public void windowClosed(WindowEvent ev) {}

    public void windowClosing(WindowEvent ev) {
        setVisible(false);
    }

    public void windowDeiconified(WindowEvent ev) {}

    public void windowIconified(WindowEvent ev) {}

    public void windowOpened(WindowEvent ev) {}

}
