/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.event.*;

/**
 * CEt[̃ANVEXi
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class MainFrameCommand implements ActionListener {
    static final int FileMenuQuit = 0;
    static final int WindowMenuStatement = 1;
    static final int WindowMenuLog = 2;
    static final int HelpMenuAbout = 3;    
    static final int Connect = 4;
    static final int DriverMangerCheckbox= 5;
    static final int SelectedDriverCheckbox= 6;
    static final int RegisterDriver = 7;
    static final int DeregisterDriver = 8;

    int id;
    MainFrame module;
    MainFrameGUI gui;

    public MainFrameCommand(int id, MainFrame module){
	this.id = id;
	this.module = module;
	this.gui = module.gui;
    }

    public void actionPerformed(ActionEvent ev){
	switch (id){
	case FileMenuQuit:
	    module.Quit();
	    break;
	case WindowMenuStatement:
            module.showStatementWindow();
	    break;
	case WindowMenuLog:
            module.showLogWindow();
	    break;
	case Connect:
	    module.Connect();
	    break;
	case RegisterDriver:
            module.showAddDriverDialog();
	    break;
	case DeregisterDriver:
            module.deregisterDriver();
	    break;
	}

    }
}
