/*
 * Copyright (c) 1996 by Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package  COM.Sun.Japan.yjs.mwt;

import  java.awt.*;
import  java.awt.event.*;

/**
 * XN[o[tLoXB
 *
 * @version     1.4 97/01/11
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class ScrollableCanvas extends Panel implements AdjustmentListener {
    /**
     * XN[o[̕B
     */
    public static final int HORIZONTAL = 1;
    public static final int VERTICAL = 2;

    /**
     * XN[o[̗L\킷tOB
     */
    boolean withHorizontalBar;

    /**
     * cXN[o[̗L\킷tOB
     */
    boolean withVerticalBar;

    /**
     * ItEXN[t CanvasB
     */
    protected BufferedCanvas screen;

    /**
     * XN[o[B
     */
    Scrollbar horizontalBar;

    /**
     * cXN[o[B
     */
     Scrollbar verticalBar;

    /**
     * ftHgERXgN^B
     */
    public ScrollableCanvas() {
        this(-1, -1, true, true);
    }

    /**
     * ItEXN[̕ƍɎ ScrollableCanvas 
     * RXgN^B
     * @param width ItEXN[̕
     * @param height ItEXN[̍
     * <br><b>Notes:</b>ňɎw肳镝ƍ́AScrollCanvas
     * ̃LoXŜ̑傫\킷Br[E|[g̑傫ς
     * ꍇɂ́A#setSize \bh𗘗p邱ƁB
     */
    public ScrollableCanvas(int width, int height) {
        this(width, height, true, true);
    }

    /**
     * ItEXN[̕ƍAXN[o[̗L\킷tO
     * Ɏ ScrollableCanvas 𐶐RXgN^B
     * <br><b>Notes:</b>ňɎw肳镝ƍ́AScrollCanvas
     * ̃LoXŜ̑傫\킷Br[E|[g̑傫ς
     * ꍇɂ́A#setSize \bh𗘗p邱ƁB
     * @param width ItEXN[̕
     * @param height ItEXN[̍
     * @param horizontal XN[o[̗L\킷tO
     * @param vertival XN[o[̗L\킷tO
     */
    public ScrollableCanvas(int width, int height,
                            boolean horizontal, boolean vertical) {
        withHorizontalBar = horizontal;
        withVerticalBar = vertical;
        // i̐
        screen = new BufferedCanvas(width, height);
        horizontalBar = new Scrollbar(Scrollbar.HORIZONTAL, 0, width, 0, 0);
        verticalBar = new Scrollbar(Scrollbar.VERTICAL, 0, height, 0, 0);
        horizontalBar.addAdjustmentListener(this);
        verticalBar.addAdjustmentListener(this);
        // zu
        GridBagConstraints  c = new GridBagConstraints();
        GridBagLayout  l = new GridBagLayout();
        Canvas  f;
        setLayout(l);
        c.fill = GridBagConstraints.BOTH;
        c.anchor = GridBagConstraints.NORTHWEST;
        c.weightx = 1.0;
        if (withVerticalBar) {
            c.gridwidth = GridBagConstraints.RELATIVE;
            l.setConstraints(screen, c);
            add(screen);
            c.fill = GridBagConstraints.VERTICAL;
            c.weightx = 0.0;
            c.weighty = 1.0;
            c.gridwidth = GridBagConstraints.REMAINDER;
            l.setConstraints(verticalBar, c);
            add(verticalBar);
        } else {
            c.gridwidth = GridBagConstraints.REMAINDER;
            l.setConstraints(screen, c);
            add(screen);
        }
        if (withHorizontalBar) {
            c.gridwidth = GridBagConstraints.RELATIVE;
            c.fill = GridBagConstraints.HORIZONTAL;
            c.weightx = 1.0;
            c.weighty = 0.0;
            l.setConstraints(horizontalBar, c);
            add(horizontalBar);
            f = new Canvas();
            c.fill = GridBagConstraints.NONE;
            c.gridwidth = GridBagConstraints.REMAINDER;
            c.weightx = 0.0;
            c.weighty = 0.0;
            l.setConstraints(f, c);
            add(f);
        }
    }

    /**
     * TCỸZbgB
     * @param w 
     * @param h 
     */
    public synchronized void setSize(int w, int h) {
        super.setSize(w, h);
        setupScrollbar();
        doLayout();
    }

    /**
     * ړό`B
     * @param x x W
     * @param y y W
     * @param w BScrollableCanvas ̌ڂ̕B
     * @param h BScrollableCanvas ̌ڂ̍B
     */
    public synchronized void setBounds(int x, int y, int w, int h) {
        super.setBounds(x, y, w, h);
        setupScrollbar();
    }

    /**
     * ScrollableCanvas ̕`B
     * @param g `Ɏgp GraphicsB
     */
    public void paint(Graphics g) {
        screen.repaint();
    }

    /**
     * ScrollableCanvas ̃LoX(ItEXN[) Graphics ԂB
     */
    public Graphics getGraphics() {
        return screen.getBufferGraphics();
    }

    /**
     * ScrollableCanvas ̃LoX(ItEXN[)̑傫ԂB
     * #see getViewSize
     */
    public Dimension getScreenSize() {
        return screen.getSizeOfBuffer();
    }

    /**
     * ScrollableCanvas ̃LoX(ItEXN[)̑傫Zbg
     * B
     * @param d V Dimension
     */
    public void setScreenSize(Dimension d) {
        setScreenSize(d.width, d.height);
    }

    /**
     * ƍɎAScrollableCanvas ̃LoX(ItEXN
     * [)̑傫ZbgB
     * @param w 
     * @param h 
     */
    public void setScreenSize(int w, int h) {
        screen.setSizeOfBuffer(w, h);
        setupScrollbar();
        repaint();
    }

    /**
     * ScrollableCanvas ̃r[̑傫ԂB
     * #see getScreenSize
     */
    public Dimension getViewSize() {
        return screen.getSize();
    }    

    /**
     * LoX̃obNOEhEJ[ZbgAhׂB
     * @param backgroung VobNOEhJ[B
     */
    public synchronized void setCanvasBackground(Color background) {
        screen.setBackground(background);
        screen.clearBuffer();
    }

    /**
     * hׂB
     */
    public void clearCanvas() {
        screen.clearBuffer();
    }

    /**
     * XN[̃ItZbgAȂ킿ÃXN[o[
     * lԂB
     */
    public Point getOffset() {
        return new Point(horizontalBar.getValue(), verticalBar.getValue());
    }

    /**
     * adjustment value changed Cxg̃nhOB
     * @param ev adjustment value changed Cxg
     */
    public void adjustmentValueChanged(AdjustmentEvent ev) {
        int x, y;
        x = horizontalBar.getValue();
        y = verticalBar.getValue();
        screen.setOffset(x, y);
    }

    /**
     *  ScrollableCanvas Ŕ mouse Cxg󂯂
     * mouse listener ǉB
     * @param l mouse listener
     */
    public void addMouseListener(MouseListener l) {
        screen.addMouseListener(l);
    }

    /**
     *  ScrollableCanvas Ŕ mouse Cxg󂯂
     *  mouse listener OB
     * @param l mouse listener
     */
    public void removeMouseListener(MouseListener l) {
        screen.removeMouseListener(l);
    }

    /**
     * XN[o[̑傫𒲐B
     */
    protected void setupScrollbar() {
        Dimension  d = getSize();
        int  sw, sh; // means width and height of screen
        sw = d.width - verticalBar.getPreferredSize().width;
        sh = d.height - horizontalBar.getPreferredSize().height;
        if (withHorizontalBar) {
            horizontalBar.setValues(0, sw, 0, screen.getSizeOfBuffer().width - sw);
            horizontalBar.setBlockIncrement(sw);
        }
        if (withVerticalBar) {
            verticalBar.setValues(0, sh, 0, screen.getSizeOfBuffer().height - sh);
            verticalBar.setBlockIncrement(sh);
        }
    }
}
